<?php
function get_file_extension($file_name){
  return substr(strrchr($file_name,'.'),1);
}

function get_image_extension($file_name){
	$file_types = array(
		'php',
		'pdf',
		'txt',
		'psd',
		'htm', 'html',
		'avi', 'mpg', 'flv', 'mov', 'wmv', 'rm', 'mkv', 'm4v', 'mp4', 'mpeg', 'h264',
		'mp3', 'wav', 'flac', 'mid',
		'xls', 'xlsx','xlsm', 'xltx', 'xltm', 'xlsb', 'xlam',
		'doc', 'docx', 'docm', 'dotx', 'dotm',
		'ppt', 'pptx', 'pptm', 'potx', 'potm', 'ppam', 'ppsx', 'ppsm', 'sldx', 'sldm',
		'swf', 'fla',
		'rar', 'zip',
		'exe',
		'xml',
		'iso', 'cue',
		'tc', 'dpd',
		'c',
		'cc', 'ccp', 'ccx',
		'cs',
		'rb',
		'ttf', 'otf', 'fnt',
		'app',
		'css', 'less',
		'sql'
	);
	$file_name = strtolower($file_name);
	$file_ext = substr(strrchr($file_name,'.'),1);
	if(in_array($file_ext, $file_types)){
		return $file_ext;
	}else{
		return 'other';
	}
}

function bytes_to_string($size, $precision = 0) {
	$sizes = array('YB', 'ZB', 'EB', 'PB', 'TB', 'GB', 'MB', 'KB', 'B');
	$total = count($sizes);
	while($total-- && $size > 1024) $size /= 1024;
	$return['num'] = round($size, $precision);
	$return['str'] = $sizes[$total];
	return $return;
}

function time_ago($string){
    
		if(empty($string)) {
			return "No date provided";
		}
	   
		$periods = array("second", "minute", "hour", "day", "week", "month", "year", "decade");
		$lengths = array("60","60","24","7","4.35","12","10");
	   
		$string = intval($string);
		if($string == 0){
			$string++; // stop 0 seconds ago
		}

		// is it future date or past date
		if(time() > $string) {   
			$difference = time() - $string;
		} else {
			$difference = $string - time();
		}
	   
		for($j = 0; $difference >= $lengths[$j] && $j < count($lengths)-1; $j++) {
			$difference /= $lengths[$j];
		}
	   
		$difference = round($difference);
	   
		if($difference != 1) {
			$periods[$j].= "s";
		}
	   
		return "$difference $periods[$j]";
}

function is_image($i){
	$i = strtolower($i);
	
	if ( substr_count( $i, ".jpg" ) > 0  || substr_count( $i, ".jpeg" ) > 0 || substr_count( $i, ".gif" ) > 0 || substr_count( $i, ".png" ) > 0 ){
		return true;
	}
	return false;
}

function thumbnail_generation(){

	$width = 135;
	$height = 80;
	
	if (!isset($_GET['img'])) return;
	
	$image = $_GET['img'];

	
	$image_cache = "./_thumbnails" . "/" . sha1( $width . $height . $image . filesize($image)) . ".jpg";
	
	if(file_exists($image_cache)){
		header("Location: ./" . $image_cache);
		exit;
	}
	
	$imgsize = getimagesize ( $image );
	
	if($imgsize[0] > 5000 || $imgsize[1] > 5000){
		copy('assets/images/failedthumbnail.jpg', $image_cache);
		header("Location: ./" . $image_cache);
		exit;
	}
	
	
	switch ($imgsize[2]) {
		case 1: // gif
			$im	= imagecreatefromgif( $image );
			break;
		case 2: // jpg
			$im	= imagecreatefromjpeg( $image );
			break;
		case 3: // png
			$im = imagecreatefrompng( $image );
			break;
		default: // Attempting to load a non image
			copy('assets/images/failedthumbnail.jpg', $image_cache);
			header("Location: ./" . $image_cache);
			exit;
	}
	
	
	header("Content-type: image/jpg");

	$img_thumb = imagecreatetruecolor( $width, $height );
	$dsth = ($width / ImageSX($im)) * ImageSY($im);
	imagecopyresampled( $img_thumb, $im, 0,($height-$dsth)/2, 0,0, $width, $dsth, ImageSX($im), ImageSY($im) );
	imagejpeg( $img_thumb );
	// This will fail if you haven't created and chmodded your thumbnails folder
	if ( $im && $img_thumb ){
		@mkdir("_thumbnails", 0666);
		imagejpeg( $img_thumb, $image_cache, 95 ) or set_flash('Unable to write thumbnails. Please chmod your _thumbnails folder to 666', 'empty', 'Critical error');
	}
	
	imagedestroy( $img_thumb );
	imagedestroy( $im );
	exit;
}

function downloads(){

	if (!isset($_GET['dl'])) return;
	
	$dl = $_GET['dl'];
	$disallowed_files = array(
		'./index.php',
		'./assets/php/about.php',
		'./assets/php/config.php',
		'./assets/php/functions.php',
		'./assets/php/login.php',
		'./assets/php/pwgen.php',
	);


	if (!isset($_GET['dl']) || $_GET['dl'] == '') {
		$dl = '';
	} else {
		$dl = './' . preg_replace('/\/+/', '/', trim( $_GET['dl'], '/'));
	}

	if (substr_count($dl, '/.') > 0) {
	 	header('Location: ./index.php');
		exit;
	} 
	if (preg_match('/^\/?\.\./', $dl) > 0){
	 	header('Location: ./index.php');
		exit;
	}

	if (in_array($dl, $disallowed_files)) {
	 	header('Location: ./index.php');
		exit;
	}

	if(file_exists($dl)){
		$tmp = explode('/', $dl);
		$file_name = end($tmp);

		
		header('Content-disposition: attachment; filename=' . $file_name);
		header('Content-type: application/octet-stream');
		readfile($dl);		
	}

	exit;
}

function str_truncate ($str, $length=10, $trailing='...') {
      // take off chars for the trailing
      $length-=strlen($trailing);
      if (strlen($str) > $length){
         // string exceeded length, truncate and add trailing dots
         return substr($str,0,$length).$trailing;
      } 
      else { 
         // string was already short enough, return the string
         $res = $str; 
      }
  
      return $res;
}

function set_flash($message, $icon, $type){
	$_SESSION['flash_message'] = $message;
	$_SESSION['flash_icon'] = $icon;
	$_SESSION['flash_type'] = $type;
}

function clear_flash(){
	unset($_SESSION['flash_message']);
	unset($_SESSION['flash_icon']);
	unset($_SESSION['flash_type']);
}

function callback($buffer){
	$lines = explode("\n", $buffer);
	$buffer = '';
	foreach ($lines as $line){
		//Removes all indentation
		$line = preg_replace("/\t+/", "", $line);
		$line = preg_replace("/^\s+/", "", $line);
		$line = preg_replace("/[\n\r]/","",$line); 
		if(!empty($line)){
			$buffer .= $line;
		}
	}

	return $buffer;
	
}