<?php
if(!defined('VERSION')){ exit; }


if(isset($_POST['password']) && isset($_POST['p_width']) && isset($_POST['image_limit']) && isset($_POST['remember']) && isset($_POST['downloads']) ){
	session_start();
	require('assets/php/functions.php');

	$password = $_POST['password'];
	$p_width = intval($_POST['p_width']);
	$image_limit = intval($_POST['image_limit']);
	$remember = intval($_POST['remember']);
	$downloads = $_POST['downloads'];


	if($password != ''){
		$password_salt = uniqid('', true);
		$password_hash = sha1($password . $password_salt);
	}else{
		$password_salt = '';
		$password_hash = '';
	}

	if($downloads == 1){
		$downloads = 'true';
	}else{
		$downloads = 'false';
	}

$config = <<<config
<?php

// Config
// if PASSWORD is empty, anyone can view the directory.
// Use index.php?pwgen to generate your password and hash :)
// Value needs to be:
// sha1( password . PASSWORD_SALT )
define('PASSWORD', '$password_hash');

// Salt used to hash your password with.
define('PASSWORD_SALT', '$password_salt');

// Default width of the page. Set to multiples of 150 + 50, recommended values are: 800, 950, 1100, 1250, 1400
// Default: 800
define('AB_WIDTH', $p_width);

// How many images to show as thumbnails before listing them as like other files.
// Default: 500
define('IMAGE_LIMIT', $image_limit);

// Time to remember users in seconds. Will be forgotten if the password is changed.
// Default: 315569260 (10 years)
define('REMEMBER_LENGTH', $remember);

// If set to true, AFB will display a downloads icon to quickly download a file.
// This allows for downloads of *anything* inside AFB's directory, including .php files which will not be executed
// Default: false
define('DOWNLOADS', $downloads);
config;

	file_put_contents('./assets/php/config.php', $config);
	set_flash('Aberrant File Browser has been installed!<br/><br/>For security reasons, the installation script has been deleted.<br/>Reupload it if you wish to run the installer again. Alternatively, you can change settings by editting <code>/assets/php/code.php</code>.', 'info', 'Info');
	header('Location: index.php');
	unlink('./assets/php/install.php');
	
}


?>
<!DOCTYPE html>
<html>
<head>
	<link href="./assets/css/light.css" rel="stylesheet" type="text/css" />
	<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js"></script>
	<title>Install :: Aberrant File Browser - PersianScript.ir</title>
</head>
<body>
	<div id="wrap">
		<div class="items">
			<div class="title row home">
				<div class="location"><strong>Location: </strong> Special :: Install</div>
			</div>
		</div>


		<?php if(!empty($errors)): ?>
			<div class="items">
				<div class="title row empty">The following errors occured:</div>
				<?php foreach($errors as $error): ?>
					<div class="title row bullet"><?php echo $error; ?></div>
				<?php endforeach; ?>
			</div>
		<?php endif; ?>

		<form action="" method="POST">
		<div class="items">
			<div class="title row info">Password</div>
			<div class="title row">If you set a password, only someone with the password can view the contents of AFB. If left empty, anyone an view your files.</div>
			<div style="margin-top:5px;" class="title row">
				<input type="Password" id="password" name="password" value=""/>
			</div>

			<div class="title row info">Page Width</div>
			<div class="title row">Width of the page in pixels.</div>
			<div style="margin-top:5px;" class="title row">
			<select id="p_width" name="p_width">
				<option value="800">800</option>
				<option value="950">950</option>
				<option value="1100">1100</option>
				<option value="1250">1250</option>
				<option value="1400">1400</option>
			</select>
			</div>

			<div class="title row info">Image Limit</div>
			<div class="title row">How many images to show as thumbnails before listing them as like other files. Too many thumbnails can create scrolling lag on lower end machines and older browsers.</div>
			<div style="margin-top:5px;" class="title row">
				<input type="text" id="image_limit" name="image_limit" value="500"/>
			</div>

			<div class="title row info">Remember logged in users</div>
			<div class="title row">Time to remember users in seconds. Only applies if AFB is password protected. Defaults to 10 years.</div>
			<div style="margin-top:5px;" class="title row">
				<input type="text" id="remember" value="315569260" name="remember"/>
			</div>

			<div class="title row info">Downloads</div>
			<div class="title row">If enabled AFB will display a downloads icon to quickly download a file. This allows for downloads of <strong>anything</strong> inside AFB's directory, including .php files which will not be executed and will be downloaded as their raw source code.</div>
			<div style="margin-top:5px;" class="title row">
			<select id="downloads" name="downloads">
				<option value="0">Disable downloads</option>
				<option value="1">Enable downloads</option>
			</select>
			</div>
		</div>

		<div class="items">
			<div class="title row info">Install</div>
			<div style="margin-top:5px;" class="title">
				<input type="submit" id="install" value="Install now"/>
			</div>
		</div>
		</form>

		<div class="items">
			<div class="title"><strong>Aberrant File Browser <?php echo VERSION; ?></strong> | &copy; <?php if(date('Y') > 2011){echo '2011 &ndash;';} ; ?> <?php echo date('Y'); ?> - <a href="http://www.persianscript.ir" target="_blank"> PersianScript.ir </a></div>
		</div>
	</div>
</body>
</html>