<?php

$mtime = microtime();
$mtime = explode(" ", $mtime);
$mtime = $mtime[1] + $mtime[0];
$start_time = $mtime;


// Version
define('VERSION', '0.43');

// Development Version
define('ENV', 'production');

if(!file_exists('assets/php/config.php')){
	require('assets/php/install.php');
	exit;
}


require('assets/php/config.php');
require('assets/php/functions.php');


session_start();

// Logout
if (isset($_GET['a']) && isset($_GET['t'])) {
	if ($_GET['t'] == $_SESSION['token']) {
		setcookie('p', '', time() - 1);
		session_destroy();
		header('Location: ./index.php');
		exit;
	}
}

// If view password is blank, let everyone view the page.
if (PASSWORD == '') {
	$_SESSION['auth'] = 'view';
	$_SESSION['open'] = true;
	if (!isset($_SESSION['token'])) {
		$_SESSION['token'] = uniqid('', true);
	}
} else {
	// if this flag is set, but there is a password, it means the directory used to be open but now requires a password - so destroy the session and refresh the page.
	if (isset($_SESSION['open'])) {
		session_destroy();
		header('Location: ./index.php');
		exit;
	}
}

// Login attempt
if (isset($_POST['l'])) {
	switch (sha1($_POST['l'] . PASSWORD_SALT)) {
		case PASSWORD:
			$_SESSION['auth'] = 'view';
			$_SESSION['token'] = uniqid('', true);
			setcookie('p', PASSWORD, time() + REMEMBER_LENGTH);
			break;
		default:
			require('assets/php/login.php');
			exit;
	}
	// Redirect to allow refreshing right after a log in
	header('Location: ./index.php');
	exit;
} elseif (!isset($_SESSION['auth'])) { //No session auth found
	if (isset($_COOKIE['p']) && PASSWORD == $_COOKIE['p']) {
		$_SESSION['auth'] = 'view';
		$_SESSION['token'] = uniqid('', true);
		// header('Location: ./index.php');
		//exit;
	} else {
		require('assets/php/login.php');
		exit;
	}
}

if (isset($_GET['about'])) {
	require('assets/php/about.php');
	exit;
}
elseif (isset($_GET['pwgen'])) {
	require('assets/php/pwgen.php');
	exit;
}
// } elseif (isset($_GET['install'])) {
// 	require('assets/php/install.php');
// 	exit;
// }

thumbnail_generation();

if(DOWNLOADS == true){
	downloads();
}


$folders = array();
$images = array();
$files = array();

if (!isset($_GET['b']) || $_GET['b'] == '') {
	$browse = '';
} else {
	$browse = '/' . preg_replace('/\/+/', '/', trim( $_GET['b'], '/'));
}

// if (substr_count($browse, '/.') > 1) {
// 	set_flash('This path is invalid. If a link generated by AFB took you here, please report this as a bug', 'empty', 'Error');
// 	$browse = str_replace('/.', '', $browse);
//  	header('Location: ./index.php?b=' . $browse);
// 	exit;
// } 

// Prevents going above the root directory
//if (preg_match('/'. '\/\.{2}(?:[\W]|$)' .'/', $browse) > 0){
if (preg_match('/'. '\/\.{2}(?:[\/]|$)' .'/', $browse) > 0){
	set_flash('This path is invalid. If a link generated by AFB took you here, please report this as a bug', 'empty', 'Error');
 	header('Location: ./index.php');
	exit;
}


$dir = "./" . $browse;

$hidden_directories = array(
	'assets',
	'cgi-bin',
	'_thumbnails',
);

$hidden_files = array(
	// Internal files
	'index.php',
	'.htaccess',
	'error_log',

	// I hate macs
	'.ds_store',
	'_macosx',

	// At least this plague ended with Windows XP
	'thumbs.db',
);

$hidden_files = array_merge($hidden_directories, $hidden_files);

// open this directory 

if (!file_exists($dir)) {
	set_flash('The folder ' . substr($dir, 3) . ' could not be found', 'empty', 'Error');
	header('Location: ./index.php');
	exit;
} elseif (in_array(str_replace(array('.', '/'), '', $dir), $hidden_directories)) {
	set_flash('Access to this directory is denied', 'empty', 'Error');
	header('Location: ./index.php');
	exit;
}

$directory_x = opendir($dir);

// get each entry
while ($file = readdir($directory_x)) {

	if (in_array(strtolower($file), $hidden_files)) {
		continue;
	}

	if ($file != "." && $file != "..") {
		if (is_dir($dir . '/' . $file)) {
			$folders[] = $file;
		} elseif (is_image($dir . '/' . $file)) {
			$images[] = array($file, filesize($dir . '/' . $file), filemtime($dir . '/' . $file));
		} else {
			$files[] = array($file, filesize($dir . '/' . $file), filemtime($dir . '/' . $file));
		}
	}
}


closedir($directory_x);


asort($folders);
asort($files);
asort($images);

if (ENV == 'development') {
	ob_start();
}else{
	ob_start("callback");
}

header('X-UA-Compatible: Chrome=1');
header('X-UA-Compatible: IE=9');
?>
<!DOCTYPE html>
<html>
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

	<?php if (ENV == 'development'): ?>

		<link href="./assets/css/light.css" rel="stylesheet" type="text/css"/>
		<link href="./assets/css/colorbox.css" rel="stylesheet" type="text/css"/>

		<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
		<script type="text/javascript" src="./assets/js/jquery.colorbox.min.js"></script> <!-- 1.4.4 -->
		<script type="text/javascript" src="./assets/js/jquery.lazyload.min.js"></script> <!-- 1.8.4 -->
		<script type="text/javascript" src="./assets/js/audio-player.js"></script>
		<script type="text/javascript" src="./assets/js/afb.js"></script>

	<?php else: ?>

		<link href="./assets/css/style.css" rel="stylesheet" type="text/css"/>
		<script type="text/javascript" src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
		<script type="text/javascript" src="./assets/js/afb_all.js"></script>

	<?php endif; ?>

	<meta name="viewport" content="width=800"/>

	<?php
		$directories = explode('/', $browse);
		$folder_url = ''; $i = '0'; $title = '';
		foreach ($directories as $directory){
			$title .= (empty($directory) ? 'home' : ' / ' . $directory); 
		}
		$title .= ' :: Aberrant File Browser';
	?>

	<title><?php echo $title; ?></title>

	<style type="text/css">
		#wrap {
			width: <?php echo AB_WIDTH; ?>px;
		}
	</style>
</head>

<body>



<div id="wrap">

	<?php
	/*
	* Header
	*/
	?>
			
	<div class="items">

		<div class="title row home">
			<?php if (!($_SESSION['auth'] == 'view' && PASSWORD == '')): ?>
			<span class="size"><a href="index.php?a=logout&amp;t=<?php echo $_SESSION['token']; ?>">Logout</a></span>
			<?php endif; ?>

			<div class="location"><strong>Location: </strong>
				<?php
				$directories = explode('/', $browse);
				$folder_url = ''; $i = '0';
				foreach ($directories as $directory):
					$i++;
					if ($i == 1) {
						$folder_url .= urlencode($directory);
					} else {
						$folder_url .= urlencode('/' . $directory);
					}
					?>
					<a href="?b=<?php echo $folder_url; ?>">
						<?php echo (empty($directory) ? 'home' : ' / ' . $directory); ?> 
					</a>

				<?php endforeach;  ?>
			</div>

		</div>
	</div>

	<?php
	/*
	* Flash messages
	*/
	?>

	<?php if (isset($_SESSION['flash_message'])): ?>
		<div class="items">
			<div class="title row <?php echo $_SESSION['flash_icon']; ?>"><strong><?php echo $_SESSION['flash_type']; ?>:</strong>
				<?php echo ($_SESSION['flash_type'] == 'Info') ? $_SESSION['flash_message'] : htmlspecialchars($_SESSION['flash_message']); ?>
			</div>
		</div>
		<?php clear_flash(); ?>
	<?php endif; ?>

	<?php
	/*
	* Directories/ Folders
	*/
	?>

	<?php $image_cache_gen = 0; ?>
	<?php if (count($folders) == 0 && count($images) == 0 && count($files) == 0): ?>
		<div class="items">
			<div class="title row empty">
				This folder is empty
			</div>
		</div>
	<?php else: ?>

	<?php if (count($folders) != 0): ?>
		<div class="items">
			<div class="title"><?php echo count($folders); ?> folder<?php echo (count($folders) == 1 ? '' : 's'); ?></div>

			<table class="table">
				<?php foreach ($folders as $value): ?>
				<tr>
					<td class="tableicon">
						<div class="icon folder"></div>
					</td>
					<td><a href="?b=<?php echo $browse . '/' . rawurlencode($value); ?>"><?php echo $value; ?></a></td>
					<?php
	 				// This makes the page load 13641% slower!
					$t_dirs = count(glob('.' . $browse . '/' . $value . '/*', GLOB_ONLYDIR));
					$t_files = count(glob('.' . $browse . '/' . $value . '/*'));
					?>
					<td class="tablesize"><?php echo $t_dirs; ?> folder<?php echo ($t_dirs == 1 ? null : 's') ?></td>
					<td class="tablesize"><?php echo $t_files - $t_dirs; ?> file<?php echo ($t_files - $t_dirs == 1 ? null : 's') ?></td>

				</tr>
				<?php endforeach; ?>
			</table>


		</div>
	<?php endif; ?>


	<?php if (count($images) > 0 && count($images) < IMAGE_LIMIT): ?>

		<?php
		 /*
		 * Image Previews
		 */
		?>

		<div class="items">
			<div class="title">
				<?php echo count($images); ?> image<?php echo (count($images) == 1 ? '' : 's'); ?>
			</div>

			<?php foreach ($images as $value): ?>
				<?php
					$file_true_loc = (strlen($browse) == 0 ? $browse : substr($browse, 1) . '/');
					$thumb_loc = "_thumbnails" . "/" . sha1('135' . '80' . $file_true_loc . $value[0] . filesize($file_true_loc . $value[0]) ). ".jpg";
					if (!file_exists($thumb_loc)){
						$thumb_loc = '?img=' . $file_true_loc . $value[0];
						$image_cache_gen++;
					}

				?>

				<?php $size = bytes_to_string($value[1], 2); ?>
				<div class="image">
					<a class="dia_img" href=".<?php echo $browse . '/' . rawurlencode($value[0]); ?>" title="<?php echo $value[0]; ?> | <?php echo $size['num']; ?> <?php echo $size['str']; ?>">
						<div class="img_outer">
							<img data-original="<?php echo $thumb_loc; ?>" src="./assets/images/failedthumbnail.png" alt="" class="innerimage lazy"/>
							<div class="img_title"><span>
								<?php echo str_truncate($value[0], 25); ?><br/>
								<?php echo $size['num']; ?> <?php echo $size['str']; ?>
							</span></div>
						</div>
					</a>
				</div>
			<?php endforeach; ?>

			<div style="clear:both;"></div>
		</div>
	<?php elseif (count($images) > 0): ?>
		
		<?php
		/*
		* Images
		* (if there are too many to list as previews)
		*/
		?>
	
		<div class="items">
			<div class="title"><?php echo count($images); ?> image<?php echo (count($images) == 1 ? '' : 's'); ?></div>
			<table class="table">
				<?php foreach ($images as $value): ?>
					<tr>
						<td class="tableicon">
							<div class="icon image_icon"></div>
						</td>
						<?php $size = bytes_to_string($value[1], 2); ?>
						<td>
							<a class="dia_img" href=".<?php echo $browse . '/' . rawurlencode($value[0]); ?>" title="<?php echo $value[0]; ?> | <?php echo $size['num']; ?> <?php echo $size['str']; ?>">
								<?php echo $value[0]; ?>
							</a>

							<?php if(DOWNLOADS == true): ?>
								<a href="?dl=<?php echo $browse . '/' . rawurlencode($value[0]); ?>" style="float:right">
									<div class="icon bullet_get"></div>
								</a>
							<?php endif; ?>
						</td>
						<td class="tablesize"><?php echo $size['num']; ?> <?php echo $size['str']; ?></td>
						<td class="tablesize"><?php echo time_ago($value[2]); ?> old</td>

					</tr>
				<?php endforeach; ?>
			</table>
		</div>

	<?php endif; ?>

	<?php
	/*
	* Files
	*/
	?>

	<?php if (count($files) != 0): ?>
		<div class="items">
			<div class="title"><?php echo count($files); ?> file<?php echo (count($files) == 1 ? '' : 's'); ?></div>
			<table class="table">
				<?php foreach ($files as $value): ?>
				<?php
					$file_ext = get_file_extension(strtolower($value[0]));
					switch($file_ext){
						default:
							$class = '';
							break;
						case 'mp3':
							$class = 'dia_audio';
							break;
						case 'pdf': // http://docs.google.com/support/bin/answer.py?hl=en&answer=1189935
						case 'doc':
						case 'docx':
						case 'xls':
						case 'xlsx':
						case 'ppt':
						case 'pptx':
						case 'ai':
						case 'psd':
						case 'tiff':
						case 'dxf':
						case 'svg':
						case 'eps':
						case 'ps':
						case 'xps':
						case 'zip':
						case 'rar':
							$class = 'dia_doc';
							break;
					}

					$r_id = uniqid();
				?>

				<tr>
					<td class="tableicon">
						<div class="icon file_<?php echo get_image_extension($value[0]); ?> <?php echo $class; ?>"></div>
					</td>
					<td>
						<a href=".<?php echo $browse . '/' . rawurlencode($value[0]); ?>" class="<?php echo $class; ?>" id="a_<?php echo $r_id ?>">
							<?php echo $value[0]; ?>
						</a>
						<?php if(DOWNLOADS == true): ?>
							<a href="?dl=<?php echo $browse . '/' . rawurlencode($value[0]); ?>" style="float:right">
								<div class="icon bullet_get"></div>
							</a>
						<?php endif; ?>
					</td>
					<?php $size = bytes_to_string($value[1], 2); ?>
					<td class="tablesize"><?php echo $size['num']; ?> <?php echo $size['str']; ?></td>
					<td class="tablesize"><?php echo time_ago($value[2]); ?> old</td>

					<?php if($class == 'dia_audio'): ?>
						<td class="hidden">
							<script>
							$(document).ready(function(){
								$("#a_<?php echo $r_id ?>").click(function(event) {
									event.preventDefault();
									$.colorbox({
										inline: true,
										width: '<?php echo AB_WIDTH; ?>px',
										href: "#in_<?php echo $r_id ?>",
									});
								});
							});
							
							<?php
								$base_path = str_replace(basename(__FILE__), '', $_SERVER['SCRIPT_NAME']); 

								// http://wordpress.org/support/topic/plugin-audio-player-comma-in-mp3-title 
								if($base_path == '/'){
									$sf_path = $browse . '/' . rawurlencode(rawurlencode($value[0]));
								}else{

									$sf_path = str_replace(basename(__FILE__), '', $_SERVER['SCRIPT_NAME']) . substr($browse,1) . '/' . rawurlencode(rawurlencode($value[0]));
								}

							?>
							AudioPlayer.embed("pl_<?php echo $r_id ?>", {
								soundFile: "<?php echo $sf_path ?>"
							}); 
							</script>

							<div style="display:none">
								<div id="in_<?php echo $r_id ?>">
									<div class="audio_info">
										<p><a href=".<?php echo $browse . '/' . rawurlencode($value[0]); ?>"><?php echo $value[0]; ?></a></p>
										<p><?php echo $size['num']; ?> <?php echo $size['str']; ?> | <?php echo time_ago($value[2]); ?> old</p>
										<p id="pl_<?php echo $r_id ?>"></p>
									</div>
								</div>
							</div>
						</td>
					<?php elseif($class == 'dia_doc'): ?>

						<td class="hidden">
							<script>
							$(document).ready(function(){
								$("#a_<?php echo $r_id ?>").click(function(event) {
									event.preventDefault();
									var href = $(this).attr('href').substr(1);

									$.colorbox({
										iframe: true,
										width: '<?php echo AB_WIDTH; ?>px',
										height: '80%',
										href: function() {
											return "http://docs.google.com/gview?url=http://<?php echo $_SERVER['SERVER_NAME'] . str_replace(basename(__FILE__), '', $_SERVER['SCRIPT_NAME']) . substr($browse,1) . '/' . rawurlencode($value[0]) ?>&embedded=true"
										}
									});
								});
							});
							</script>
							<div style="display:none">
								<div id="in_<?php echo $r_id ?>">
									<div class="audio_info">
										<p><a href=".<?php echo $browse . '/' . rawurlencode($value[0]); ?>"><?php echo $value[0]; ?></a></p>
										<p><?php echo $size['num']; ?> <?php echo $size['str']; ?> | <?php echo time_ago($value[2]); ?> old</p>
										<p id="pl_<?php echo $r_id ?>"></p>
									</div>
								</div>
							</div>
						</td>
					<?php endif; ?>						
				</tr>			
				
				<?php endforeach; ?>
			</table>
		</div>

		<?php endif; ?>
	<?php endif; ?>

	<?php
	/*
	* Footer
	*/
	?>


	
	<div class="items">
		<div class="title">
			<strong>Aberrant File Browser <?php echo VERSION; ?></strong> | 
			&copy; <?php if(date('Y') > 2011){echo '2011 &ndash; ';} ; ?> <?php echo date('Y'); ?> | 
			<?php if (isset($_GET['b'])): ?>
				<a href="./index.php?about&amp;return=<?php echo $_GET['b'] ?>">About</a> | 
			<?php else: ?>
				<a href="./index.php?about">About</a> | 
			<?php endif; ?>
			<?php /* Valid <a href="http://validator.w3.org/check?uri=referer">HTML 5</a> and <a href="http://jigsaw.w3.org/css-validator/check/referer?profile=css3">CSS</a> | */ ?>
			<?php if ($image_cache_gen > 0): ?>Generated <?php echo $image_cache_gen; ?> new thumbnail<?php echo ($image_cache_gen == 1 ? '' : 's'); ?> | <?php endif; ?>
			<?php $mtime = microtime();$mtime = explode(" ", $mtime);$mtime = $mtime[1] + $mtime[0];$end_time = $mtime;$total_time = ($end_time - $start_time); ?>
			Page generated in <?php echo round($total_time, 6); ?> seconds
		</div>
	</div>
</div>


</body>
</html>
<?php ob_end_flush(); ?>